library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity main is
	port (
				CLK		: in std_logic;
				RESET    : in std_logic;
				POSITION : out std_logic_vector(3 downto 0);
				DISPLAY  : out std_logic_vector(7 downto 0)           
         );
end main;

architecture Behavioral of main is
-------------------------------------------------------------
--
--    KOMPONENTY
--		==========
-------------------------------------------------------------
-------------------------------------------------------------
component zobrazovac is
	generic (number_of_segments : integer := 4);
	port (	CLK : in std_logic;
				DIGITS  : in std_logic_vector((number_of_segments * 4)-1 downto 0);
				POSITION : out std_logic_vector(number_of_segments-1 downto 0);
				DISPLAY  : out std_logic_vector(7 downto 0)
			);
end component;
-------------------------------------------------------------
  component clk_divisor is
   generic (divisor : natural );
   port (
      CLK_INPUT  : in std_logic;
      RESET      : in std_logic;
      CLK_OUTPUT : out std_logic
   );
   end component;
-------------------------------------------------------------
   component rotate_vector is
    generic (str_len : natural := 13);
    port (
      CLK, RESET : in std_logic;
      MOVE_CHAR : in std_logic;
      OUTPUT : out std_logic_vector(15 downto 0)
      );
   end component;
-------------------------------------------------------------
   signal numbers : std_logic_vector(15 downto 0);
   signal move_char : std_logic;
begin
-------------------------------------------------------------
--
-- Propojeni
--
-------------------------------------------------------------
i_Zobrazovac : zobrazovac
	port map (
	  	CLK => CLK,
		DIGITS => numbers,
		POSITION => POSITION,
		DISPLAY => DISPLAY
	);
-------------------------------------------------------------
i_Clk_Divisor : clk_divisor
   generic map (divisor => 12_500_000 ) -- citani po 0,250 s
   port map (
      CLK_INPUT => CLK,
      RESET     => RESET,
      CLK_OUTPUT => move_char -- casovani posouvani textu
   );
-------------------------------------------------------------
i_Rotate_Vector : rotate_vector
      port map (
         CLK => CLK,
         RESET => RESET,
         MOVE_CHAR => move_char,
         OUTPUT => numbers
      );

end Behavioral;
