library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity rotate_vector is
   generic (str_len : natural := 13);
   port (
      CLK, RESET : in std_logic;
      MOVE_CHAR : in std_logic;
      OUTPUT : out std_logic_vector(15 downto 0)
      );
end rotate_vector;

architecture Behavioral of rotate_vector is
 constant encoded_text : std_logic_vector((str_len * 4) - 1 downto 0) := X"5555012301420";
 signal code_str : std_logic_vector((str_len * 4) - 1 downto 0);
begin

moving_text:
   process(CLK, RESET)
   begin
      if RESET = '1' then
         code_str <= encoded_text; 
      elsif CLK = '1' and CLK'event then
         if MOVE_CHAR = '1' then
            code_str <= code_str(str_len*4 - 5 downto 0) & code_str(str_len*4 - 1 downto str_len*4 - 4);
         end if;
      end if;
   end process; 
   
   OUTPUT <= code_str((str_len * 4) - 1 downto ((str_len * 4) - OUTPUT'length));
end Behavioral;


